Bug 799618 - Memory leak in error-handling case in _librsync_new_deltamaker found in duplicity-0.6.17-2.fc17 using gcc-with-cpychecker static analyzer
Memory leak in error-handling case in _librsync_new_deltamaker found in dupli...
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: duplicity (Show other bugs)
19
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Rahul Sundaram
Fedora Extras Quality Assurance
http://fedorapeople.org/~dmalcolm/gcc...
:
Depends On:
Blocks: cpychecker
  Show dependency treegraph
 
Reported: 2012-03-03 10:50 EST by Dave Malcolm
Modified: 2014-04-10 21:52 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-04-10 21:52:23 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Dave Malcolm 2012-03-03 10:50:59 EST
Description of problem:
I've been writing an experimental static analysis tool to detect bugs commonly occurring within C Python extension modules:
  https://fedorahosted.org/gcc-python-plugin/
  http://gcc-python-plugin.readthedocs.org/en/latest/cpychecker.html
  http://fedoraproject.org/wiki/Features/StaticAnalysisOfPythonRefcounts

I ran the latest version of the tool (in git master; post 0.9) on
duplicity-0.6.17-2.fc17.src.rpm, and it reports various errors.

You can see a list of errors here, triaged into categories (from most significant to least significant):
http://fedorapeople.org/~dmalcolm/gcc-python-plugin/2012-03-03/duplicity-0.6.17-2.fc17/

I've manually reviewed the issues reported by the tool.

Within the category "Reference leaks" the 1 issue reported appears to be a genuine leak for the error-handling case where the result from rs_job_iter(sig_loader, &buf) != RS_DONE: the _librsync_DeltaMakerObject object allocated will not be released for the lifetime of the process; there needs to be a:
    Py_DECREF(dm);
before the
    return NULL;

Within the category "Reference leak within initialization" the 1 issue reported appears to be inconsequential (this code is called once on module import).

Within the category "Segfaults within error-handling paths" the 3 issues reported could only happen under very low memory-conditions when the module is first imported.

Within the category "Returning (PyObject*)NULL without setting an exception" the 4 issues reported appear to be false positives: the checker doesn't know that  _librsync_seterror() presumably sets the exception state for the current thread.

There may of course be other bugs in my checker tool.

Hope this is helpful; let me know if you need help reading the logs that the tool generates - I know that it could use some improvement.

Version-Release number of selected component (if applicable):
duplicity-0.6.17-2.fc17
gcc-python-plugin post-0.9 git 57a93b9426e8bfdb2787d1f6ee3941e1e475abab running the checker in an *f16* chroot
Comment 1 Fedora End Of Life 2013-04-03 13:14:54 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 2 Fedora Admin XMLRPC Client 2013-12-26 01:18:23 EST
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 3 Rahul Sundaram 2013-12-27 17:50:10 EST
Can anyone kindly check with the current release please?  Thanks
Comment 4 Rahul Sundaram 2014-04-10 21:52:23 EDT
Closing.  If anyone can reproduce this, please reopen

Note You need to log in before you can comment on or make changes to this bug.